import re, os, sys
import urllib
import urllib2
import json
import requests
import xbmcplugin
import xbmcgui
import xbmcaddon


addon_id = 'plugin.video.spuul-rain'
Addon = xbmcaddon.Addon(addon_id)
addon_version = Addon.getAddonInfo('version')
addon_name = Addon.getAddonInfo('name')
debug = Addon.getSetting('debug')

username = (Addon.getSetting('username'))
password = (Addon.getSetting('password'))
subsoption = (Addon.getSetting('subsoption'))
moviessort = (Addon.getSetting('moviessortType')).lower()

s=requests.Session()

base_url = "https://spuul.com"
aci = "75628660ffc9c2e75d310ffd785d755979e795a08cba04166d3565812660b5f1"
acs = "0fa6644db57cd10efbbc11077b78f781e7d2bfcd999349014fa0303e024bc94a"
gt = "client_credentials"

headers = {'Accept':'application/json, text/javascript, */*; q=0.01', 'Accept-Encoding':'gzip, deflate, br', 'Connection':'keep-alive', 'User-Agent':'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/52.0.2743.116 Safari/537.36', 'Referer':base_url, 'Origin':base_url}	


apidata = {'client_id':aci, 'client_secret':acs, 'grant_type':gt}

def addon_log(string):
    if debug == 'true':
        xbmc.log("[plugin.video.spuul-rain-%s]: %s" %(addon_version, string))
		
def get_menu():
	if (username=='' or password==''):
		xbmcgui.Dialog().ok("Authentication Error","This addon requires user credentials under settings,","free accounts available on Spuul.com")
		addon_log('Username or Password are not entered')
		sys.exit()
	else:
		headers['Content-Type']='application/x-www-form-urlencoded; charset=UTF-8'
		r = requests.post('https://api.spuul.com/oauth/token', data=apidata, headers=headers, verify=False)
		rjson = r.json()
		at= rjson['access_token']
		
		apidata['grant_type']='password'
		apidata['email_or_msisdn']=username
		apidata['password']=password
		apidata['access_token']=at
		headers['Referer']='https://spuul.com/login'
		headers['Accept'] = 'application/vnd.spuul.v3'
		headers['Origin']=base_url
		r2 = requests.post('https://api.spuul.com/oauth/token', data=apidata, headers=headers, verify=False)
		r2json = r2.json()
		new_at = r2json['access_token']
		
		headers['Content-Type']=''
		headers['Referer']='https://spuul.com/browse'
		
		html = s.get('https://api.spuul.com/named_query_groups?name=app.screens.browse&access_token='+new_at, headers=headers, verify=False).json()
		for h in html[0]['named_queries']:
			addDir(2, '[COLOR orange][B]'+h['title']+'[/B][/COLOR]', 'https://api.spuul.com/named_queries/'+str(h['id'])+'/items?page=1&per_page=30&access_token='+new_at, h['image'])
	
def movie_plans():
	addDir(3, 'All movies (Free + Premium)', url, '')
	addDir(3, 'Free movies', url.replace('items?','items?free=true&'), '')
	addDir(3, '[COLOR orange][B]Premium movies[/B][/COLOR]', url.replace('items?','items?premium=true&'), '')
	addDir(3, 'Search Movies in all languages', url, '')
	
def get_movies(url):
	if name=='Search Movies in all languages':
		keyb = xbmc.Keyboard('', 'Search for Movies in all languages')
		keyb.doModal()
		search_term=''
		if (keyb.isConfirmed()):
			search_term = urllib.quote_plus(keyb.getText())
			if not search_term:
				xbmcgui.Dialog().ok(addon_name+' - '+addon_version, 'Empty search not allowed!')
				sys.exit()			
		else:
			sys.exit()
		if search_term!='':
			at = url.split('access_token=')[1]
			url = 'https://api.spuul.com/videos/search?keywords='+str(search_term)+'&access_token='+at
	headers['Accept'] = 'application/vnd.spuul.v3'
	headers['Referer'] = 'https://spuul.com/browse'
	req2 = s.get(url, headers=headers, verify=False)
	r2 = req2.json()
	at = url.split('access_token=')[1]
	infoList={}
	for r in r2:
		full_tag_link = 'https://api.spuul.com/videos/'+str(r['id'])+'/video_sources?renderer=local&access_token='+at
		tag_img = r['cover']['small']
		is_hd2 = r['hd']
		is_premium = r['prices'][0]['free']
		addon_log('movie name: %s' %r['title'])
		addon_log ('is premium: %s' %is_premium)
		infoList.update({'Duration':r['length'], 
						'Title' : r['title'],
						'Cast'  : r['actors'].split(','),
						'Director' : r['director'],
						'Year':r['production_year'],
						'PlotOutline' : r['synopsis'],
						'Plot' : r['summary'],
						'Rating':r['rating']})
		subs = r['subtitles']
		if subs is not None and len(subs)>0: subs=True
		else: subs=False
		if is_premium==False:
			addon_log('under if %s' %is_premium)
			title = '[COLOR orange]'+r['title']+'[/COLOR]'
		else:
			title = r['title']
		addDir(11, title, full_tag_link, r['cover']['small'],is_hd2,infoList,subs, True)

	if 'Links' in req2.headers:
		my_list = requests.utils.parse_header_links(req2.headers['Links'].rstrip('>').replace('>,<', ',<'))
		for k in my_list:
			if k['rel']=='next':
				next = k['url']
				addDir(3, '[COLOR orange]>>> Next Page >>>[/COLOR]', next, '')
			
	if (moviessort == "name"):
		xbmcplugin.addSortMethod( handle=int( sys.argv[ 1 ] ), sortMethod=xbmcplugin.SORT_METHOD_LABEL )		
	
def get_video_url():
	headers['Accept'] = 'application/vnd.spuul.v3'
	headers['Referer']=base_url+name
	s.headers=headers
	subsurl = ''
	if subsoption=='true':
		if subtitles:
			try:
				subsget = s.get(subtitles, headers=headers, verify=False).json()
				subsurl = subsget[0]['format']['srt']
			except:
				dialog.notification("Trouble fetching subtitles!", "Subtitles Error", xbmcgui.NOTIFICATION_INFO, 4000)
	
	r3 = s.get(url, headers=headers, cookies=s.cookies, verify=False)
	raw3 = r3.json()
	raw3_url=''
	
	for r in raw3:
		if r['quality']=='full':
			rendition_token = r['rendition_token']
			raw3_url = r['url']
			break
		else: raw3_url = None
			
	if raw3_url:

		# raw3resp = s.get(raw3_url, headers=s.headers, cookies=s.cookies, verify=False)
		# addon_log('raw3resp is: %s' %raw3resp.content)
		# regex1= re.compile('NAME=".+?",.+?\n(.+?)\n', re.DOTALL).findall(raw3resp.content)[4]
		# # addon_log('regex is: %s' %regex)
		# regex = raw3_url.split('s_slim.m3u8')[0]+regex1
		
	
		s.cookies['request_rendition_token'] = rendition_token
		s.headers['X-Requested-With'] = 'ShockwaveFlash/22.0.0.209'
		cookieString = ""
		c = s.cookies
		i = c.items()
		for name2, value in i:
			cookieString+= name2 + "=" + value + ";"
	
		listitem =xbmcgui.ListItem(name)
		listitem.setProperty('IsPlayable', 'true')
		if subsurl != "" : listitem.setSubtitles([subsurl])
		listitem.setPath(raw3_url+'|User-Agent=Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/52.0.2743.116 Safari/537.36&Cookie='+cookieString)
		xbmcplugin.setResolvedUrl(int(sys.argv[1]), True, listitem)	

def addDir(mode,name,url,image,is_hd=None,videoInfo={},subtitles=False,isplayable=False):
	name = name.encode('utf-8', 'ignore')
	url = url.encode('utf-8', 'ignore')
	image = image.encode('utf-8', 'ignore')

	if 0==mode:
		link = url
	else:
		if subtitles:
			suburl = url.replace('video_sources?renderer=local', 'video_subtitles?')
			link = sys.argv[0]+"?mode="+str(mode)+"&name="+urllib.quote_plus(name)+"&url="+urllib.quote_plus(url)+"&image="+urllib.quote_plus(image)+'&subtitles='+urllib.quote_plus(suburl)
		else:
			link = sys.argv[0]+"?mode="+str(mode)+"&name="+urllib.quote_plus(name)+"&url="+urllib.quote_plus(url)+"&image="+urllib.quote_plus(image)

	ok=True
	item=xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=image)
	item.setInfo('Video', videoInfo)
	if is_hd:
		video_info = {'codec': 'h264','aspect': 1.78,'width': 1280,'height': 720,}
	else:
		video_info = {'codec': 'h264', 'aspect': 1.78,}
	item.addStreamInfo('video', video_info)
	item.addStreamInfo('audio', {'codec': 'aac', 'language': 'en', 'channels': 2})
	image2 = image.replace('/small_', '/')
	item.setArt({'fanart': image2})
	isfolder=True
	if isplayable:
		item.setProperty('IsPlayable', 'true')
		isfolder=False
	ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=link,listitem=item,isFolder=isfolder)
	return ok

def get_params():
	param=[]
	paramstring=sys.argv[2]
	if len(paramstring)>=2:
		params=sys.argv[2]
		cleanedparams=params.replace('?','')
		if (params[len(params)-1]=='/'):
			params=params[0:len(params)-2]
		pairsofparams=cleanedparams.split('&')
		param={}
		for i in range(len(pairsofparams)):
			splitparams={}
			splitparams=pairsofparams[i].split('=')
			if (len(splitparams))==2:
				param[splitparams[0]]=splitparams[1]
	return param

params=get_params()
mode=None
name=None
url=None
image=None
subtitles=None

try:
	mode=int(params["mode"])
except:
	pass
try:
	name=urllib.unquote_plus(params["name"])
except:
	pass
try:
	url=urllib.unquote_plus(params["url"])
except:
	pass
try:
	image=urllib.unquote_plus(params["image"])
except:
	pass
try:
	subtitles=urllib.unquote_plus(params["subtitles"])
except:
	pass
	
addon_log("Mode: "+str(mode))
addon_log("Name: "+str(name))
addon_log("URL: "+str(url))
addon_log("Image: "+str(image))
addon_log("Subtitles: "+str(subtitles))

if mode==None:
	get_menu()
	
if mode==2: movie_plans()

if mode==3:
	get_movies(url)
 
if mode==11:
	get_video_url()

s.close()
xbmcplugin.endOfDirectory(int(sys.argv[1]), cacheToDisc=True)
